from PIL import Image

im = Image.open('graphics.png')

pal = im.getpalette()[:3*16]
px = im.load()

with open('graphics.h', 'w') as fp:
    print('/* Generated by convert.py from artwork/bomb-animation/graphics.png */', file=fp)
    print('struct RGB { uint8_t r, g, b; } GRAPHICS_PALETTE[] = {', file=fp)
    for i in range(0, 16*3, 3):
        print('  { 0x%02x, 0x%02x, 0x%02x }, ' % tuple(pal[i:i+3]), file=fp)
    print('};', file=fp)
    print('const uint8_t GRAPHICS_PIXELS_PACKED[] = {', file=fp)
    for y in range(im.height):
        for x in range(0, im.width, 2):
            print(end='0x%02x,' % ((px[x,y] << 4) | (px[x+1,y])), file=fp)
        print(file=fp)
    print('};', file=fp)
    print('struct Img16C { uint16_t width, height; const uint8_t *data; } graphics = {', file=fp)
    print('  %d, %d, GRAPHICS_PIXELS_PACKED };' % (im.width, im.height), file=fp)
